"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function range(x) {
    const up = (() => {
        function* from(begin = 0) {
            if (begin >= x)
                return;
            yield begin;
            yield* from(begin + 1);
        }
        function to(end = 0) {
            return range(end).up.from(x);
        }
        return { from, to, [Symbol.iterator]: from };
    })();
    const down = (() => {
        function* from(begin = 0) {
            if (begin <= x)
                return;
            yield begin;
            yield* from(begin - 1);
        }
        function to(end = 0) {
            return range(end).down.from(x);
        }
        return { from, to, [Symbol.iterator]: to };
    })();
    return { up, down, [Symbol.iterator]: up.from };
}
exports.default = range;
//# sourceMappingURL=index.js.map