"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const map_1 = tslib_1.__importDefault(require("../map"));
function split(iterable, choose) {
    return split.func(iterable, choose);
}
exports.split = split;
(function (split) {
    function* func(iterable, choose) {
        let list = Array();
        for (const item of iterable) {
            if (choose(item)) {
                yield { list, line: item, last: false };
                list = [];
            }
            else {
                list.push(item);
            }
        }
        yield { list, line: undefined, last: true };
    }
    split.func = func;
    function line(iterable, separator, compare = line.DEFAULT_COMPARATOR) {
        return map_1.default(func(iterable, x => compare(separator, x)), x => x.list);
    }
    split.line = line;
    (function (line) {
        line.DEFAULT_COMPARATOR = Object.is;
    })(line = split.line || (split.line = {}));
})(split = exports.split || (exports.split = {}));
exports.default = split;
//# sourceMappingURL=index.js.map