"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function zip(a, b, provideKeys = zip.FIRST) {
    const akeys = Object.keys(a);
    const bkeys = Object.keys(b);
    const keys = provideKeys(akeys, bkeys);
    const result = {};
    for (const name of keys) {
        result[name] = [a[name], b[name]];
    }
    return result;
}
exports.zip = zip;
(function (zip) {
    zip.FIRST = a => a;
    zip.INNER_JOIN = (a, b) => a.length < b.length ? b.filter(x => a.includes(x)) : a.filter(x => b.includes(x));
    zip.OUTER_JOIN = (a, b) => new Set(a.concat(b));
})(zip = exports.zip || (exports.zip = {}));
exports.default = zip;
//# sourceMappingURL=index.js.map